#include <iostream>
#include <fstream>
#include <list>
#include <clocale>
#include <cstdlib>

#include "lineInter.h"

int main()
{
    setlocale(LC_ALL, "Russian");

    TableFunction f;
    TableFunction g;

    bool working = true;
    while (working)
    {
        std::string answer;     //   
        //  
        system("cls");

        std::cout << "1 -    \n"
                  << "2 -   \n"
                  << "3 -     \n"
                  << "4 -    \n"
                  << "5 -    \n"
                  << "6 -    \n"
                  << "0 -   \n\n"
                  << ": ";

        std::getline(std::cin, answer);
        if (answer == "1")
        {
            //    
            std::cout << "1 -  f\n"
                      << "2 -  g\n";
            std::string answer;
            std::getline(std::cin, answer);

            if (answer == "1")
            {
                std::cout << " f\n"
                          << "   : ";
                std::getline(std::cin, answer);
                if ( f.loadFromFile(answer.c_str()) )
                {
                    std::cout << "  \n";
                }
                else
                {
                    std::cout << "   \n";
                }
            }
            else if (answer == "2")
            {
                std::cout << " g\n"
                          << "   : ";
                std::getline(std::cin, answer);
                if ( g.loadFromFile(answer.c_str()) )
                {
                    std::cout << "  \n";
                }
                else
                {
                    std::cout << "   \n";
                }
            }
            else
            {
                std::cout << "   \n";
            }
            system("pause");
        }
        else if (answer == "2")
        {
            //  
            std::cout << "1 -  f\n"
                      << "2 -  g\n";
            std::string answer;
            std::getline(std::cin, answer);

            if (answer == "1")
            {
                std::cout << " f\n";
                if ( f.linearApproximate() )
                {
                    std::cout << "  \n";
                    std::cout << " : " << f.getFunctionOfLinearApproximation();
                    std::cout << "\n\n";
                }
                else
                {
                    std::cout << "  \n";
                }
            }
            else if (answer == "2")
            {
                std::cout << " g\n";
                if ( g.linearApproximate() )
                {
                    std::cout << "  \n";
                    std::cout << " : " << g.getFunctionOfLinearApproximation();
                    std::cout << "\n\n";
                }
                else
                {
                    std::cout << "  \n";
                }
            }
            else
            {
                std::cout << "   \n";
            }
            system("pause");
        }
        else if (answer == "3")
        {
            //     
            std::cout << "1 -  f\n"
                      << "2 -  g\n";
            std::string answer;
            std::getline(std::cin, answer);

            if (answer == "1")
            {
                std::cout << " f\n";
                std::cout << "    : ";
                int number;
                if ( !(std::cin >> number) )
                {
                    std::cin.clear();
                    while (std::cin.get() != '\n')
                        continue;

                    std::cout << " \n";
                    system("pause");
                    continue;
                }

                if ( f.linearApproximateAndChangeDX(number) )
                {
                    std::cout << "  \n";
                    std::cout << " : " << f.getFunctionOfLinearApproximation();
                    std::cout << "\n\n";
                }
                else
                {
                    std::cout << "  \n";
                }
            }
            else if (answer == "2")
            {
                std::cout << " g\n";
                std::cout << "    : ";
                int number;
                if ( !(std::cin >> number) )
                {
                    std::cin.clear();
                    while (std::cin.get() != '\n')
                        continue;

                    std::cout << " \n";
                    system("pause");
                    continue;
                }

                if ( g.linearApproximateAndChangeDX(number) )
                {
                    std::cout << "  \n";
                    std::cout << " : " << g.getFunctionOfLinearApproximation();
                    std::cout << "\n\n";
                }
                else
                {
                    std::cout << "  \n";
                }
            }
            else
            {
                std::cout << "   \n";
            }
            std::cin.get();
            system("pause");
        }
        else if (answer == "4")
        {
            //    
            std::cout << "1 -  f\n"
                      << "2 -  g\n";
            std::string answer;
            std::getline(std::cin, answer);

            if (answer == "1")
            {
                std::cout << " f\n"
                          << "   : ";
                std::getline(std::cin, answer);
                if ( f.saveToFile(answer.c_str()) )
                {
                    std::cout << "  \n";
                }
                else
                {
                    std::cout << "    \n";
                }
            }
            if (answer == "2")
            {
                std::cout << " g\n"
                          << "   : ";
                std::getline(std::cin, answer);
                if ( g.saveToFile(answer.c_str()) )
                {
                    std::cout << "  \n";
                }
                else
                {
                    std::cout << "    \n";
                }
            }
            else
            {
                std::cout << "   \n";
            }
            system("pause");
        }
        else if (answer == "5")
        {
            //    
            std::cout << "1 -  f  g (  f  g)\n"
                      << "2 -  f  g (  f  g)\n"
                      << "3 -  f  g (  f  g)\n"
                      << "4 -   f \n"
                      << "5 -   g \n"
                      << "6 -  f  \n"
                      << "7 -  g  \n"
                      << "0 -   \n\n"
                      << ": ";
            std::getline(std::cin, answer);
            if (answer == "1")
            {
                //  f  g
                std::cout << "f + g:\n";
                std::cout << f + g;
            }
            else if (answer == "2")
            {
                //  f  g
                std::cout << "f - g:\n";
                std::cout << f - g;
            }
            else if (answer == "3")
            {
                //  f  g
                std::cout << "f * g:\n";
                std::cout << f * g;
            }
            else if (answer == "4")
            {
                //   f 
                std::cout << "     f: ";
                int i;
                if ( !(std::cin >> i) )
                {
                    std::cin.clear();
                    while (std::cin.get() != '\n')
                        continue;

                    std::cout << " \n";
                    system("pause");
                    continue;
                }

                f += i;
                std::cout << "  g  :\n";
                std::cout << f;
            }
            else if (answer == "5")
            {
                //   g 
                std::cout << "     g: ";
                int i;
                if ( !(std::cin >> i) )
                {
                    std::cin.clear();
                    while (std::cin.get() != '\n')
                        continue;

                    std::cout << " \n";
                    system("pause");
                    continue;
                }

                g *= i;
                std::cout << "  g  :\n";
                std::cout << g;
            }
            else if (answer == "6")
            {
                //  f  
                std::cout << "    f: ";
                int i;
                if ( !(std::cin >> i) )
                {
                    std::cin.clear();
                    while (std::cin.get() != '\n')
                        continue;

                    std::cout << " \n";
                    system("pause");
                    continue;
                }

                f *= i;
                std::cout << " f  :\n";
                std::cout << f;
            }
            else if (answer == "7")
            {
                //  g  
                std::cout << "    g: ";
                int i;
                if ( !(std::cin >> i) )
                {
                    std::cin.clear();
                    while (std::cin.get() != '\n')
                        continue;

                    std::cout << " \n";
                    system("pause");
                    continue;
                }

                g *= i;
                std::cout << " g  :\n";
                std::cout << g;
            }
            else if (answer == "0")
            {
                //   
                continue;
            }
            else
            {
                std::cout << "   \n";
            }
            system("pause");
        }
        else if (answer == "6")
        {
            //    
            std::cout << "1 -  f\n"
                      << "2 -  g\n";
            std::string answer;
            std::getline(std::cin, answer);

            if (answer == "1")
            {
                std::cout << f << '\n';
            }
            else if (answer == "2")
            {
                std::cout << g << '\n';
            }
            else
            {
                std::cout << "   \n";
            }
            system("pause");
        }
        else if (answer == "0")
        {
            working = false;
        }
        else
        {
            std::cout << "   \n";
            system("pause");
        }
    }

    return 0;
}
